//
//  DFTAudio.m
//  Tour
//
//  Created by Nick on 3/6/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "DFTAudio.h"
#import "TourStop.h"

@implementation DFTAudio
@synthesize is_playing;
@synthesize cur_frame;
@synthesize parent;

- (id) initWithJSON:(NSMutableDictionary *)db_json
{
    self =[super initWithJSON:db_json];
    self.is_playing=0;
    return self;
}
// probs should be using some sort of delegate..
- (id) initWithJSON:(NSMutableDictionary *)db_json withParent:(TourStop*)p
{
    self = [super initWithJSON:db_json];
    self.is_playing=0;
    self.parent=p;
    return self;
}

-(id) initWithUUID:(NSString *)teh_uuid
{
    self = [super initWithUUID:teh_uuid];
    self.is_playing=0;
    return self;
}

- (void) audio_callback:(Float32 *)buffer with_framesize:(UInt32) framesize
{
//    NSLog(@".");
    if (!is_playing)
        return;
    
    float *my_buff = (float *)[[self data] bytes];
    int total_frames= [[self data] length]/(2*sizeof(float));
    
    for (int i=0; i<framesize;++i){
        if (cur_frame<total_frames){
            if ((is_playing ==1) || is_playing == 2){
                buffer[2*i]+=my_buff[2*cur_frame];
            }
            if ((is_playing == 1) || is_playing ==3)
            {
                buffer[2*i+1]+=my_buff[2*cur_frame+1];
            }
//            assert(buffer[2*i]==buffer[2*i+1]);
            ++cur_frame;
        }
        else{
            [self stop_audio];
            break;
        }
    }
    
    return;
}

- (void) stop_audio
{
    is_playing=0;
    cur_frame=0;
    if (parent)
    {
        [[self parent] audioChildDidStop];
    }
}

- (void) start_audio
{
//    NSLog(@"starting!");
    if (!is_playing){
        is_playing=rand()%3+1;
//        NSLog(@"%d",is_playing);
        cur_frame=0;
    }
//    if (parent)
//    {
//        [[self parent] audioChildDidStart];
//    }
}



@end
