//
//  DFTMedia.m
//  Tour
//
//  Created by Nick on 3/6/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "DFTMedia.h"


@implementation DFTMedia

@synthesize db_path;
@synthesize local_path;
@synthesize uuid;
@synthesize geo_loc;
@synthesize data;
@synthesize connex;
@synthesize stop_primary;
@synthesize heading;
@synthesize xacc;
@synthesize yacc;
@synthesize zacc;


-(id) initWithJSON:(NSMutableDictionary *)db_json
{
    self =[super init];
    
    NSString *local_dir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
    
    NSDictionary *db_fields=[db_json objectForKey:@"fields"];
//    self.name = [sound_fields objectForKey:@"name"];
    self.uuid = [db_fields objectForKey:@"uuid"];
    // save to local?
    self.db_path = [NSString stringWithFormat:@"http://arthur.stanford.edu/tour/mediapair/%@",uuid];
    self.local_path = [NSString stringWithFormat:@"%@/%@",local_dir,self.uuid];
    self.geo_loc =[[CLLocation alloc]  initWithLatitude:[[db_fields objectForKey:@"lat"] floatValue] longitude:[[db_fields objectForKey:@"long"] floatValue]];
    self.heading = [[db_fields objectForKey:@"heading"] floatValue];
    self.xacc = [[db_fields objectForKey:@"xacc"] floatValue];
    self.yacc = [[db_fields objectForKey:@"yacc"] floatValue];
    self.zacc = [[db_fields objectForKey:@"zacc"] floatValue];
    
//    connex=connect;
    
    return self;

}

-(id) initWithUUID:(NSString *)teh_uuid withData:(NSData*)teh_data
{
    self = [super init];
    self.uuid=teh_uuid;
    self.data=teh_data;
    NSString *local_dir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
    self.local_path = [NSString stringWithFormat:@"%@/%@",local_dir,self.uuid];
    self.db_path = [NSString stringWithFormat:@"http://arthur.stanford.edu/tour/mediapair/%@",uuid];
    
    return self;
}

-(id) initWithUUID:(NSString *)teh_uuid
{
    self = [super init];
    self.uuid=teh_uuid;
    NSString *local_dir = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) objectAtIndex:0];
    self.local_path = [NSString stringWithFormat:@"%@/%@",local_dir,self.uuid];
    self.db_path = [NSString stringWithFormat:@"http://arthur.stanford.edu/tour/mediapair/%@",self.uuid];
    [self loadFile];
    
    return self;
}

-(void) loadFile
{
    NSFileManager *fmer = [NSFileManager defaultManager];
    if ([fmer fileExistsAtPath:self.local_path])
    {
//        NSLog(@".");
        self.data=[NSData dataWithContentsOfFile:self.local_path];
        return;
    }
    else
    {

        NSURL *url = [NSURL URLWithString:db_path];
        self.data = [NSData dataWithContentsOfURL:url];
//        NSLog(@"+");
//        NSLog(@"Tried to write to path: %@", local_path);
        [[self data] writeToFile:self.local_path atomically:NO];
        
        return;
    }
}


+ (NSString*) stringWithUUID {
    CFUUIDRef uuidObj = CFUUIDCreate(nil);//create a new UUID
    //get the string representation of the UUID
    NSString *uuidString = (__bridge NSString*)CFUUIDCreateString(nil, uuidObj);
    CFRelease(uuidObj);
    return uuidString;
}


@end
