//
//  DFTViewController.h
//  Tour
//
//  Created by Nick on 3/6/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <AVFoundation/AVFoundation.h>
#import "AVCamCaptureManager.h"
#import "DFTConnection.h"

#import "TourStop.h"
#import "DFTMedia.h"
#import "DFTAudio.h"
#import "DFTMediaPair.h"


@interface DFTViewController : UIViewController 

@property (strong, nonatomic) IBOutlet UISwipeGestureRecognizer *SwipeRight;
@property (strong, nonatomic) IBOutlet UISwipeGestureRecognizer *SwipeLeft;
@property (strong, nonatomic) IBOutlet UIImageView *BackgroundImage;
@property (nonatomic,retain) AVCamCaptureManager *captureManager;
@property (weak, nonatomic) IBOutlet UIButton *CLICKER;
@property (nonatomic,retain) IBOutlet UIView *videoPreviewView;
@property (nonatomic,retain) AVCaptureVideoPreviewLayer *captureVideoPreviewLayer;
@property (weak, nonatomic) IBOutlet UIImageView *ForegroundImage;
@property (strong, nonatomic) IBOutlet UISwipeGestureRecognizer *SwipeDown;
@property (strong, nonatomic) IBOutlet UISwipeGestureRecognizer *SwipeUp;
@property (weak, nonatomic) IBOutlet UIView *LoadingView;
@property (strong, nonatomic) UIImage *prevImage;
@property (strong, nonatomic) UIImage *curImage;


@property (weak, nonatomic) DFTConnection *connex;

@property (nonatomic) int cur_stop_num;
@property (strong,nonatomic) TourStop *cur_stop;
@property (strong,nonatomic) TourStop *prev_stop;
@property (strong,nonatomic) TourStop *next_stop;
// recently recorded pair
@property (strong, nonatomic) DFTMediaPair *recked_pair;

@property (strong,nonatomic) NSString *cur_audio_path;
@property (strong,nonatomic) NSMutableDictionary *cur_params;


// maybe include global params here?

- (NSMutableDictionary *) baseParamDict;
- (void) gatherMedia;
- (void) startRecord;
- (NSString*) stopRecord;
- (void) cancelRecord;

- (void) updateSound;
- (void) updateImage;

// updates with random
- (void) randomator;

- (void) goNextStop;
- (void) goPrevStop;

- (void) updateImage;
- (void) updateImageWithRecent;
- (void) updatePairWithImgPath:path withAudioPath:audio_path;

- (void) animateCover;
// adds loading view and calls turnOffInterfax
- (void) startLoading;
// drops the loading view
- (void) stopLoading;
// turns off swipes and buttons
- (void) turnOffInterax;
// turns 'em back on
- (void) turnOnInterax;


@end
