//
//  DFTViewController.m
//  Tour
//
//  Created by Nick on 3/6/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "DFTViewController.h"
#import "AVCamUtilities.h"
#import <AVFoundation/AVFoundation.h>
#import "mo_def.h"
#import "mo_audio.h"
#import "mo_accel.h"


#define SRATE 44100
#define FRAMESIZE 512
#define NUMCHANNELS 2
#define LAST_STOP_NUM 9 // meaning there's 10 stops


float g_x_accel;
float g_y_accel;
float g_z_accel;

bool g_is_recording;
bool g_is_animating;
bool g_is_shakabake;

bool g_is_disping;

float *g_out_buff;
int g_out_pos;
int g_max_out_pos;

int g_image_refresh;
int g_sound_refresh;

int callback_count;

NSMutableArray *imageset;
NSMutableArray *audioset;


// global functions
void fakeCallback(Float32 *buff, UInt32 frameSize, void* userData);
void fakeCallback(Float32 *buff, UInt32 frameSize, void* userData)
{
    return;
}

void audioCallback(Float32 * buff, UInt32 frameSize, void * userData);
void audioCallback(Float32 * buff, UInt32 frameSize, void * userData)
{
    @autoreleasepool {
        DFTViewController *cur_vc = (__bridge DFTViewController*) userData;
        if (!g_is_disping){
            [cur_vc performSelectorOnMainThread:@selector(updateImage) withObject:nil waitUntilDone:NO];
        }
                   
        // update db
    //    if ((++callback_count)%200==0)
    //        [cur_vc performSelectorOnMainThread:@selector(gatherMedia) withObject:nil waitUntilDone:NO];
        
        // update image
        
//        if (rand()%100==0)
//            [cur_vc performSelectorOnMainThread:@selector(updateImage) withObject:nil waitUntilDone:NO];
//        // update sound
//        if (rand()%100==0)
//            [cur_vc performSelectorOnMainThread:@selector(updateSound) withObject:nil waitUntilDone:NO];

        for (int i = 0; i < frameSize; i++)
        {
            if (g_is_recording)
            {
                g_out_buff[g_out_pos++]=buff[i*NUMCHANNELS];
                g_out_buff[g_out_pos++]=buff[i*NUMCHANNELS+1];
                if (g_out_pos>=g_max_out_pos)
                {
                    [cur_vc cancelRecord];
                }
                
            }
            buff[i * NUMCHANNELS] = buff[i*NUMCHANNELS+1]=0;
            //        if (readBuffer && didRead)
            //        {
            //            buff[i * NUMCHANNELS] = (*readBuffer)[i * NUMCHANNELS];
            //            buff[i * NUMCHANNELS + 1] = (*readBuffer)[i * NUMCHANNELS + 1];
            //        }
            //        else
            //        {
            //            buff[i * NUMCHANNELS] = buff[i * NUMCHANNELS + 1] = 0;
            //        }
        }
        
        if (!([[cur_vc recked_pair] audio] == [[[cur_vc cur_stop] cur_pair] audio]))
            [[[cur_vc recked_pair] audio] audio_callback:buff with_framesize:frameSize];
        [[cur_vc cur_stop] audio_callback:buff with_framesize:frameSize];
//        [[cur_vc cur_stop] audio_callback:buff with_framesize:frameSize];
    }
}

void accelCallback(double x, double y, double z, void * user_data);
void accelCallback(double x, double y, double z, void * user_data){
//    float deltax,deltay,deltaz;
    float deltax=x-g_x_accel;
    float deltay=y-g_y_accel;
    float deltaz=z-g_z_accel;
    
    g_x_accel=x;
    g_y_accel=y;
    g_z_accel=z;
    
    float total_force=powf(deltax,2)+powf(deltay,2)+powf(deltaz,2);
//    NSLog(@"%f",total_force);
    if ((total_force>2.5) and !g_is_shakabake)
    {
        g_is_shakabake=true;
        DFTViewController *cur_vc = (__bridge DFTViewController*) user_data;
        NSLog(@"shakeababy!");
        
        [cur_vc performSelectorOnMainThread:@selector(randomator) withObject:nil waitUntilDone:NO];
//        [cur_vc performSelectorOnMainThread:@selector(animateCover) withObject:nil waitUntilDone:NO];
    }
}


// DFTViewController functions

@interface DFTViewController (AVCamCaptureManagerDelegate) <AVCamCaptureManagerDelegate>
@end

@interface DFTViewController ()
{
    CLLocationManager *locationManager;
}
@end

@implementation DFTViewController
@synthesize connex;
@synthesize ForegroundImage;
@synthesize BackgroundImage;
@synthesize prevImage;
@synthesize curImage;

@synthesize CLICKER;
@synthesize SwipeRight;
@synthesize SwipeLeft;
@synthesize SwipeDown;
@synthesize SwipeUp;
@synthesize LoadingView;
//@synthesize SwipeUp;

@synthesize captureManager;
@synthesize videoPreviewView;
@synthesize captureVideoPreviewLayer;

@synthesize cur_stop_num;
@synthesize prev_stop;
@synthesize cur_stop;
@synthesize next_stop;

// recently recorded pair
@synthesize recked_pair;

@synthesize cur_audio_path;
@synthesize cur_params;

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // make loading view see through
    [[self LoadingView] setAlpha:0.0f];
    
    self.recked_pair = [[DFTMediaPair alloc] init];
    
    // init location manager
    locationManager = [[CLLocationManager alloc] init];
    [locationManager startUpdatingLocation];
    [locationManager startUpdatingHeading];
    
    // init client to connect to database
    connex = [DFTConnection sharedClient];
    
    // init acceleration globals
    g_x_accel=0;
    g_y_accel=0;
    g_z_accel=0;
    
    // this flag is used to get the first img displayed
    g_is_disping=0;
    // this flag is to avoid lots of shakes
    g_is_shakabake=0;
    
    // init audio recording buffer and stuff
    g_out_pos=0;
    g_max_out_pos=10*2*SRATE; // maximum of ten seconds
    g_is_recording=false;
    g_out_buff=new float[g_max_out_pos];
    memset(g_out_buff,0,sizeof(float)*g_max_out_pos);
    
    // animation
    g_is_animating=false;
    
    // init the audio layer
    bool result = MoAudio::init(SRATE, FRAMESIZE, NUMCHANNELS);
    if (!result) {
        NSLog(@"cannot initialize real-time audio!");
        return;
    }
    
    // init with title
    cur_stop_num=-1;
//    __weak DFTViewController* weakself = self;
    
    self.cur_stop = [[TourStop alloc] initRandWithVC:self];
//    self.prev_stop = [[TourStop alloc] initRandWithVC:self]; 
//    self.next_stop = [[TourStop alloc] initRandWithVC:self];
//    [[self CLICKER] setEnabled:NO];
    
    
    if ([self captureManager] == nil) {
        self.captureManager = [[AVCamCaptureManager alloc] init];
//        __weak DFTViewController *weak_self = self;
        [[self captureManager] setDelegate:self];
        [[self captureManager] continuousFocusAtPoint:CGPointMake(.5f, .5f)];
        
//		self.captureManager.DFTdelegate = self; // maybe should be weak?
        
		if ([[self captureManager] setupSession]) {
		
            // Start the session. This is done asychronously since -startRunning doesn't return until the session is running.
			dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
				[[[self captureManager] session] startRunning];
			});
		}		
	}
    
	// Do any additional setup after loading the view, typically from a nib.
    
    // init callbacks
    @autoreleasepool {
        result = MoAudio::start(audioCallback, (__bridge void*)self);
        //    result = MoAudio::start(fakeCallback, NULL);
        MoAccel::addCallback( accelCallback, (__bridge void*)self);
    }
    
}

- (void)viewDidUnload
{
    [self setSwipeRight:nil];
    [self setSwipeLeft:nil];
    [self setBackgroundImage:nil];
    [self setCLICKER:nil];
    [self setForegroundImage:nil];
    [self setSwipeDown:nil];
//    [self setSwipeUp:nil];
    [self setSwipeUp:nil];
    [self setLoadingView:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation == UIInterfaceOrientationPortrait);
    } else {
        return YES;
    }
}

# pragma mark - Interaction

- (IBAction)didCLICK:(id)sender {         
    // Capture a still image
    [[self CLICKER] setEnabled:NO];
    
    cur_audio_path=[self stopRecord];
    cur_params = [self baseParamDict];
    [cur_params setObject:[cur_audio_path lastPathComponent] forKey:@"audio_uuid"];
    
    [[self captureManager] captureStillImageDump];
    
    // Flash the screen white and fade it out to give UI feedback that a still image was taken
//    UIView *flashView = [[UIView alloc] initWithFrame:[[self videoPreviewView] frame]];
//    [flashView setBackgroundColor:[UIColor blackColor]];
//    [[[self view] window] addSubview:flashView];

//    [UIView animateWithDuration:.4f
//                     animations:^{
//                         [[self blueView] setAlpha:0.f];
//                     }
//                     completion:^(BOOL finished){
//                         [[self blueView] setAlpha:1.0f];
//                         return;
//                         [flashView removeFromSuperview];
//                     }
//     ];
}
- (IBAction)didStartClick:(id)sender {
    [self startRecord];
}
- (IBAction)didCancelClick:(id)sender {
    [self cancelRecord];
}


- (IBAction)didSwipeRight:(id)sender {
    NSLog(@"swipin");
    [[self cur_stop] prevPair];
    self.recked_pair = [[self cur_stop] cur_pair];
    [self updateImage];
    [self updateSound];
    
//    [self goPrevStop];
//    NSLog(@"attempting to swipe");
//    [self updateImage];
//    [self updateSound];

//    if (imageset && [imageset count]){
//        NSInteger len=[imageset count];
//        int randi=int((float(rand())/RAND_MAX)*len);
//        [[self BackgroundImage] setImage:[UIImage imageWithData:[[imageset objectAtIndex:randi] data]]];
//    }
//    
//    if (audioset && [audioset count]){
//        NSInteger len=[audioset count];
//        int randi=int((float(rand())/RAND_MAX)*len);
//        [[audioset objectAtIndex:randi] start_audio];
//    }
}
- (IBAction)didSwipeLeft:(id)sender {
    NSLog(@"swipin");
    [[self cur_stop] nextPair];
    self.recked_pair = [[self cur_stop] cur_pair];
    [self updateImage];
    [self updateSound];
    
//    [self goNextStop];
//    if ([cur_stop audios_loaded] && [cur_stop images_loaded])
//    {
////        NSLog(@"starting audio");
//        [cur_stop startAudioChild];
//    }
//    else
//    {
//        NSLog(@"audio %@",(BOOL)[cur_stop audios_loaded]);
//        NSLog(@"images %@",(BOOL)[cur_stop images_loaded]);
//    }
    
//    [self gatherMedia];
}
- (IBAction)didTap:(id)sender {
//    NSLog(@"%@",cur_stop.primary_image.db_path);
//    NSLog(@"%@",[[[cur_stop images] objectAtIndex:[cur_stop cur_img]] db_path]);
//    [self animateCover];
}

- (IBAction)didSwipeDown:(id)sender {
    [self startLoading];
    [[[self recked_pair] audio] stop_audio];// hack
    self.cur_stop = [[TourStop alloc] initWithAudioFromPair:[self recked_pair] withVC:self];
                     
//    NSLog(@"%@",[[[cur_stop images] objectAtIndex:[cur_stop cur_img]] db_path]);
//    [self animateCover];
}
- (IBAction)didSwipeUP:(id)sender
{
    [self startLoading];
    self.cur_stop = [[TourStop alloc] initWithImageFromPair:[self recked_pair] withVC:self];
//    self.cur_stop=[cur_stop initWithStopnum:cur_stop_num withVC:self];
}

# pragma mark - delegate?

- (void)captureManagerStillImageCaptured:(DFTViewController*)vc
{
    [[self CLICKER] setEnabled:YES];
//    [[self BackgroundImage] image] = [[UIImage alloc] initWithData:imageData];
//    NSLog(@"wowzer! delegate worked!");

}
- (void)captureManagerStillImageCapturedWithImage:(UIImage*)imageData
{
    [[self CLICKER] setEnabled:YES];
    [[self BackgroundImage] setImage:imageData];
}

- (void)captureManagerStillImageCapturedWithImage:(UIImage*)imageData intoPath:(NSString *)path
{
    [[self CLICKER] setEnabled:YES];
    
    [[self BackgroundImage] setImage:imageData];
    
    [cur_params setObject:[path lastPathComponent] forKey:@"image_uuid"];
    // should maybe be copying data over to a new dictionary so as to not be modifying vars that are queued to be uploaded
    [self updatePairWithImgPath:path withAudioPath:cur_audio_path];
    [connex uploadPairWithImgPath:path withAudioPath:cur_audio_path withParams:cur_params];
    //    [self gatherMedia];
}
# pragma mark - db stuff
- (void) gatherMedia
{
    // TODO load next stop, cur stop and prev stop
    
    // grab images
    NSMutableDictionary *imageParams = [self baseParamDict];
    [imageParams setObject:[NSNumber numberWithInt:1] forKey:@"media_type"]; // 1 for image
    
    [connex getPath:@"tour/mediapair" parameters:imageParams success:^(__unused AFHTTPRequestOperation *operation, id JSON) {
        NSLog(@"GOT JSON: %@", JSON);
        
        NSMutableArray *mutableRecords = [NSMutableArray array];
        for (NSMutableDictionary *media_json in JSON) {
            DFTMedia *tmp=[[DFTMedia alloc] initWithJSON:media_json];
            [tmp loadFile];
            [mutableRecords addObject:tmp];
        }
        imageset = mutableRecords;
        //        [self.soundTableView reloadData];
    } failure:^(__unused AFHTTPRequestOperation *operation, NSError *error) {
        NSLog(@"FAILURE, %@", error);
    }];
    
    
    // grab audio
    NSMutableDictionary *audioParams = [self baseParamDict];
    [audioParams setObject:[NSNumber numberWithInt:0] forKey:@"media_type"]; // 0 for audio
    
    [connex getPath:@"tour/mediapair" parameters:audioParams success:^(__unused AFHTTPRequestOperation *operation, id JSON) {
        NSLog(@"GOT JSON: %@", JSON);
        
        NSMutableArray *mutableRecords = [NSMutableArray array];
        for (NSMutableDictionary *media_json in JSON) {
            DFTAudio *tmp=[[DFTAudio alloc] initWithJSON:media_json];
            [tmp loadFile];
            [mutableRecords addObject:tmp];
        }
        audioset = mutableRecords;
        //        [self.soundTableView reloadData];
    } failure:^(__unused AFHTTPRequestOperation *operation, NSError *error) {
        NSLog(@"FAILURE, %@", error);
    }];
//    [params setObject:[NSNumber ] forKey:@"heading"];
}

# pragma mark - helpers
- (void) startRecord
{
    memset(g_out_buff,0,sizeof(float)*g_max_out_pos);
    g_out_pos=0;
    g_is_recording=true;
    return;
}

- (void) cancelRecord
{
    g_is_recording=false;
    return;
}
- (NSString *) stopRecord
{
    g_is_recording=false;
    
    NSString *fname = [DFTMedia stringWithUUID];
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *path = [[paths objectAtIndex:0] stringByAppendingPathComponent:fname];
    
    NSLog(@"attempting to write to path %@",path);
    
    NSData *rec = [NSData dataWithBytes:g_out_buff length:(g_out_pos*sizeof(float))];
    [rec writeToFile:path atomically:NO];
    
    g_out_pos = 0;
    return path;
}

// create a dictionary of parameters to be sent to the server
- (NSMutableDictionary *) baseParamDict
{
    CLLocation *location = [locationManager location];
    NSMutableDictionary * params = [[NSMutableDictionary alloc] init];
    
    CLLocationCoordinate2D coordinate = location.coordinate;
    CLLocationDegrees latitude = coordinate.latitude;
    CLLocationDegrees longitude = coordinate.longitude;

    [params setObject:[NSNumber numberWithFloat:latitude] forKey:@"lat"];
    [params setObject:[NSNumber numberWithFloat:longitude] forKey:@"long"];
    
    float heading;
    if (![CLLocationManager headingAvailable]){
        NSLog(@"heading doesn't appear to be enabled...");
        heading=0.0;
    }
    else
    {
        CLHeading *head = [locationManager heading];
        heading = head.magneticHeading;
//        NSLog(@"true heading:%f",head.trueHeading);
        float accu = head.headingAccuracy;
        if (accu<0)
            heading = (float(rand())/RAND_MAX)*360.0f; // random heading if it's not working
//        NSLog(@"magnetic heading:%f",head.magneticHeading);
//        NSLog(@"heading accuracy:%f",head.headingAccuracy); 
        
    }
    
    [params setObject:[NSNumber numberWithFloat:heading] forKey:@"heading"];
    [params setObject:[NSNumber numberWithFloat:g_x_accel] forKey:@"xacc"];
    [params setObject:[NSNumber numberWithFloat:g_y_accel] forKey:@"yacc"];
    [params setObject:[NSNumber numberWithFloat:g_z_accel] forKey:@"zacc"];
    
    return params;
}

- (void) updateSound
{
//    NSLog(@"updateSound called");
    [[[self recked_pair] audio] start_audio];
//    [[[[self cur_stop] cur_pair] audio] start_audio];
    
//    [cur_stop startAudioChild];
//    if (audioset && [audioset count]){
//        NSInteger len=[audioset count];
//        int randi=int((float(rand())/RAND_MAX)*len);
//        [[audioset objectAtIndex:randi] start_audio];
//    }
    g_is_shakabake=false;//?
}
- (void) updatePairWithImgPath:path withAudioPath:audio_path
{
    self.recked_pair=[[DFTMediaPair alloc] initWithImgPath:path withAudioPath:audio_path];
    [self updateImageWithRecent];
    
}

- (void) randomator
{
    [self startLoading];
    self.cur_stop = [[TourStop alloc] initRandWithVC:self];  
}

- (void) updateImage
{
    curImage= [[self cur_stop] getThaImg];
    
    if (curImage)
    {
        g_is_disping=true;
        self.recked_pair = [[self cur_stop] cur_pair];
    }
    [[self BackgroundImage] setImage:curImage];
    [[self ForegroundImage] setImage:prevImage];
    
    [self animateCover];
//    [[self ForegroundImage] setImage:[UIImage imageWithData:[[cur_pair img] data]]];
    
    
//    NSLog(@"updateImage called");
//    [[self BackgroundImage] setImage:[cur_stop randImage]];
//    [[self ForegroundImage] setImage:[cur_stop primaryImage]];

////    NSLog(@"updating?");
}

- (void) updateImageWithRecent
{
    curImage= [UIImage imageWithData:[[[self recked_pair] img] data]];
    [[self BackgroundImage] setImage:curImage];
    [[self ForegroundImage] setImage:prevImage];
    
    [self animateCover];
//    [[self BackgroundImage] setImage:[cur_stop primaryImage]];
//    [[self ForegroundImage] setImage:[cur_stop primaryImage]];
}

- (void) animateCover
{
    if (!g_is_animating){
        g_is_animating=true;
        [[self ForegroundImage] setAlpha:1.0f];
        [UIView animateWithDuration:0.35f
                         animations:^{
                             [[self ForegroundImage] setAlpha:0.0f];
                         }
                         completion:^(BOOL finished){
                             prevImage=curImage;
//                             [[self ForegroundImage] setAlpha:0.0f];
//                             NSLog(@"upinit");
//                             [[self coverView] setAlpha:0.f];
                             g_is_animating=false;
                             //                         return;
                             //                         [flashView removeFromSuperview];
                         }
         ];
    }
}


- (void) startLoading
{
    [self turnOnInterax];
    [[self LoadingView] setAlpha:0.0f];
    [UIView animateWithDuration:0.5f
                     animations:^{
                         [[self LoadingView] setAlpha:0.8f];
                     }
                     completion:^(BOOL finished){
                         
                     }
     ];
}

- (void) stopLoading
{
    [UIView animateWithDuration:0.5f
                     animations:^{
                         [[self LoadingView] setAlpha:0.0f];
                     }
                     completion:^(BOOL finished){
                         
                     }
     ];
    [self turnOnInterax];
}

- (void) turnOffInterax
{
    [[self CLICKER] setEnabled:NO];
    [[self SwipeUp] setEnabled:NO];
    [[self SwipeDown] setEnabled:NO];
    [[self SwipeLeft] setEnabled:NO];
    [[self SwipeRight] setEnabled:NO];
}

- (void) turnOnInterax
{
    [[self CLICKER] setEnabled:YES];
    [[self SwipeUp] setEnabled:YES];
    [[self SwipeDown] setEnabled:YES];
    [[self SwipeLeft] setEnabled:YES];
    [[self SwipeRight] setEnabled:YES]; 
//    g_is_shakabake=0;
}

//- (void) goNextStop
//{
//    
//    //currently at title
////    if (cur_stop_num==-1){
////        ++cur_stop_num;
////        cur_stop=next_stop;
////        next_stop=[[TourStop alloc] initWithStopnum:cur_stop_num+1 withVC:self];
////    }
//    if (cur_stop_num<LAST_STOP_NUM-1)
//    {
//        //turn on camera
//        if (cur_stop_num==-1)
//            [[self CLICKER] setEnabled:YES];
//        ++cur_stop_num;
//        self.prev_stop=nil;
//        self.prev_stop=self.cur_stop;
//        self.cur_stop=self.next_stop;
////        self.next_stop=[[TourStop alloc] initWithStopnum:cur_stop_num+1 withVC:self];
//        self.next_stop = [[TourStop alloc] initRandWithVC:self];
//    }
//    else if (cur_stop_num==LAST_STOP_NUM-1)
//    {
//        ++cur_stop_num;
//        self.prev_stop=nil;
//        self.prev_stop=self.cur_stop;
//        self.cur_stop=self.next_stop;
//        // next stop is title
//        self.next_stop = [[TourStop alloc] initRandWithVC:self];
////        self.next_stop=[[TourStop alloc] initWithStopnum:-1 withVC:self];
//    }
//    // display title view
//    else if (cur_stop_num==LAST_STOP_NUM)
//    {
//        // turn off camera
//        [[self CLICKER] setEnabled:NO];
//        cur_stop_num=-1;
//        self.prev_stop=nil;
//        self.prev_stop=self.cur_stop;
//        self.cur_stop=self.next_stop;
//        self.next_stop = [[TourStop alloc] initRandWithVC:self];
////        self.next_stop=[[TourStop alloc] initWithStopnum:cur_stop_num+1 withVC:self];
//    }
//    
//    [self updateImageWithPrimary];
//    [self updateSound];
//    NSLog(@"%d",cur_stop_num);
//}

//- (void) goPrevStop
//{   
//    
//    // on title page
//    if (cur_stop_num==-1)
//    {
//        cur_stop_num=LAST_STOP_NUM;
//        self.next_stop=nil;
//        self.next_stop=self.cur_stop;
//        self.cur_stop=self.prev_stop;
//        [[self CLICKER] setEnabled:YES];
//        self.prev_stop = [[TourStop alloc] initRandWithVC:self];
////        self.prev_stop=[[TourStop alloc] initWithStopnum:cur_stop_num-1 withVC:self];
//    }
//    // going to title page
//    else if (cur_stop_num==0)
//    {
//        --cur_stop_num;
//        self.next_stop=nil;
//        self.next_stop=self.cur_stop;
//        self.cur_stop=self.prev_stop;
//        [[self CLICKER] setEnabled:NO];
//        self.prev_stop = [[TourStop alloc] initRandWithVC:self];
////        self.prev_stop=[[TourStop alloc] initWithStopnum:LAST_STOP_NUM withVC:self];
//        
//    }
//    else if (cur_stop_num>0)
//    {
//        --cur_stop_num;
//        self.next_stop=nil;
//        self.next_stop=self.cur_stop;
//        self.cur_stop=self.prev_stop;
//        self.prev_stop = [[TourStop alloc] initRandWithVC:self];
////        self.prev_stop=[[TourStop alloc] initWithStopnum:cur_stop_num-1 withVC:self];
//    }
//    
//    [self updateImageWithPrimary];
//    [self updateSound];
//    NSLog(@"%d",cur_stop_num);
//        
//}


@end
